//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  DimGray
#property indicator_color3  PaleVioletRed
#property indicator_style2  STYLE_DOT

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    BandsPeriod      = 3;
extern int    BandsPrice       = 8;
extern int    DeviationsPeriod = 7;

//
//
//
//
//

double bandup[];
double banddn[];
double bandmi[];
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   SetIndexBuffer(0,bandup);
   SetIndexBuffer(1,bandmi);
   SetIndexBuffer(2,banddn);
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { bandup[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for(i=limit; i>=0; i--) 
      {
         double linreg    = iLinr(getPrice(BandsPrice,i),BandsPeriod,i);
         double deviation = iDeviation(linreg,DeviationsPeriod,i);
         if (i>Bars-1)
         {
            bandup[i] = linreg;
            banddn[i] = linreg;
            bandmi[i] = linreg;
            continue;
         }         
         
         //
         //
         //
         //
         //
         
         bandup[i] = bandup[i+1];
         bandmi[i] = bandmi[i+1];
         banddn[i] = banddn[i+1];
         if (linreg>bandup[i+1] || linreg<banddn[i+1])
         {
            bandup[i] = linreg+2.0*deviation;
            banddn[i] = linreg-2.0*deviation;
            bandmi[i] = linreg;
         }
      }      
      return(0);
   }
   
   //
   //
   //
   //
   //
         
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         bandup[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPeriod,BandsPrice,DeviationsPeriod,0,y);
         bandmi[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPeriod,BandsPrice,DeviationsPeriod,1,y);
         banddn[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsPeriod,BandsPrice,DeviationsPeriod,2,y);
   }   
   return(0);
}


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double getPrice(int type, int i)
{
   switch (type)
   {
      case 7 : return((Open[i]+High[i]+Low[i]+Close[i])/4.0);
      case 8 : return((Open[i]+High[i]+Low[i]+Close[i]+Close[i])/5.0);
      default : return(iMA(NULL,0,1,0,MODE_SMA,MathMax(MathMin(type,6),0),i));
   }
}

//
//
//
//
//

double workDev[];
double iDeviation(double value, double period, int r, bool isSample=false)
{
   if (ArraySize(workDev)!=Bars) ArrayResize(workDev,Bars); r = Bars-r-1;
   
   //
   //
   //
   //
   //

      period = MathMax(MathMin(period,r+1),1);
      workDev[r] = value; 
         double avg = 0; for (int k=0; k<period; k++) avg += workDev[r-k]; avg /= period;
         double sum = 0; for (    k=0; k<period; k++) sum += MathPow((workDev[r-k]-avg),2);
         if (isSample)
               return(MathSqrt(sum/(period-1.0)));
         else  return(MathSqrt(sum/period));
}

//
//
//
//
//

double workLinr[];
double iLinr(double price, double period, int r)
{
   if (ArraySize(workLinr)!= Bars) ArrayResize(workLinr,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
   
      period = MathMax(MathMin(period,r+1),1);
      workLinr[r] = price;
         double lwmw = period; double lwma = lwmw*price;
         double sma  = price;
         for(int k=1; k<period && (r-k)>=0; k++)
         {
            double weight = period-k;
                   lwmw  += weight;
                   lwma  += weight*workLinr[r-k];  
                   sma   +=        workLinr[r-k];
         }             
   
   return(3.0*lwma/lwmw-2.0*sma/period);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}